/***********************************************************************
 * Copyright (c) 2003 University of Kent.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Common Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.cs.kent.ac.uk/projects/ocl/CPL.html
 ***********************************************************************/

package uk.ac.kent.cs.ocl20.semantics.bridge;

public interface BridgeFactory {
	/** Build a Property */
	Property buildProperty(Classifier ret, String op_name);

	/** Build an Operation */ 
	Operation buildOperation(Classifier ret, String op_name, Classifier params[]);

	/** Build a NamedElement */ 
	NamedElement buildNamedElement(String name, ModelElement referredElement, Boolean mayBeImplicit);

	/** Build an Environment */ 
	Environment buildEnvironment();
	
	OclModelElementType buildOclModelElementType(Object o);

	Enumeration_ buildEnumeration(Object o);

	EnumLiteral buildEnumLiteral(Object o);

	Classifier buildClassifier(Object o);
	
	ModelElement buildModelElement(Object o);

	Namespace buildNamespace(Object o);

	Property buildProperty(Object o);
}
