/***********************************************************************
 * Copyright (c) 2003 University of Kent.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Common Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.cs.kent.ac.uk/projects/ocl/CPL.html
 ***********************************************************************/

package uk.ac.kent.cs.ocl20.standard.lib;

import java.lang.reflect.Method;

/**
 * @author dha
 *
 */
public class OclAnyModelElementImpl extends OclAnyImpl implements OclAnyModelElement {

	java.lang.Object modelElement;
	public OclAnyModelElementImpl(java.lang.Object modelElem, StdLibAdapter adapter) {
		super(adapter);
		this.modelElement = modelElem;
	}

	public Object clone() {
		try {
			Method m = modelElement.getClass().getMethod("clone",new Class[]{});
			return m.invoke(modelElement, new Object[]{});
		} catch (Exception e) {
			e.printStackTrace();
		}
		return null;
	}

	public boolean equals(Object o) {
		if (o instanceof OclAnyModelElement)
			return modelElement.equals( ((OclAnyModelElement)o).asJavaObject() );
		return false;
	}

	public Object asJavaObject() {
		return modelElement;
	}

	public String toString() {
		return modelElement.toString();
	}

}
