/***********************************************************************
 * Copyright (c) 2003 University of Kent.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Common Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.cs.kent.ac.uk/projects/ocl/CPL.html
 ***********************************************************************/

package uk.ac.kent.cs.ocl20.standard.lib;

/**
 * @author dha
 *
 */
public class OclTypeImpl extends OclAnyImpl implements OclType {

	java.lang.Class cls;

	public OclTypeImpl(Class cls, StdLibAdapter adapter) {
		super(adapter);
		this.cls = cls;
	}

	public Object clone() {
		return new OclTypeImpl(this.cls, super.adapter);
	}

	public boolean equals(Object o) {
		if (o instanceof OclTypeImpl)
			return this.cls == ((OclTypeImpl)o).cls;
		return false;
	}

	public Object asJavaObject() {
		return cls;
	}

	public String toString() {
		return "OclType("+cls.getName()+")";
	}

}
