/***********************************************************************
 * Copyright (c) 2003 University of Kent.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Common Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.cs.kent.ac.uk/projects/ocl/CPL.html
 ***********************************************************************/

/**
 * 
 * @author Octavian Patrascoiu
 *
 */

package uk.ac.kent.cs.ocl20.synthesis;

import java.util.HashMap;
import java.util.Map;
import java.util.Set;

public class RuntimeEnvironmentImpl
implements RuntimeEnvironment
{
	public RuntimeEnvironmentImpl() {
		bindings = new HashMap();
	}

	protected RuntimeEnvironment parent;
	public RuntimeEnvironment getParent() {
		return parent;
	}
	public void setParent(RuntimeEnvironment p) {
		parent = p;
	}

	protected Map bindings;

	public Object getValue(String name) {
		Object value = bindings.get(name);
		if (value == null) {
			if (parent != null) value = parent.getValue(name);
		}
		return value;
	}
	public void setValue(String name, Object value) {
		bindings.put(name, value);
	}
	
	public Set getKeys() {
		return bindings.keySet();
	}

	public RuntimeEnvironment newEnvironment() {
		RuntimeEnvironment newEnv = new RuntimeEnvironmentImpl();
		newEnv.setParent(this);
		return newEnv;
	}
}
